#!/usr/bin/perl
# Shapergraph
# This script reads the traffic data from the tc command output
# 27.4.2004, Philipp Haeuser  www.funkbird.de
use strict;

my $time = time();
my %bytes;
my %pkts;
my %dropped;
my %overlimit;

print "shapevis v1.2 (05.03.2006) by Philipp \"Birdy\" Haeuser\n\n";


open TC, "tc -s -d class show dev eth4 |";
# Do not forget to put the right interface here (e.g. eth4) ^^^

my $class = "";
while (<TC>) {
        chomp;
        if (/^class htb (\d+:\d+)/) {
                $class = $1;
                print "DEBUG: Found class=$class ($_)\n";
        } elsif (/^ Sent (\d+) bytes (\d+) pkts \(dropped (\d+), overlimits (\d+)/) {
                $bytes{$class} = $1;
                $pkts{$class}  = $2;
                $dropped{$class} = $3;
                $overlimit{$class} = $4;
                print "DEBUG: Found values: $1 $2 $3 $4 ($_)\n";
        } elsif (/^ Sent (\d+) bytes/) { # Fallback, wenn die Zeile doch anders aussieht
                $bytes{$class} = $1;
        }
} 

print "\n\n";
print "DEBUG: Linux Time is ".$time."\n";
print "\n";
print "DEBUG: 1:10 =  ".$bytes{"1:10"}."\n";
print "DEBUG: 1:110 = ".$bytes{"1:110"}."\n";  
print "DEBUG: 1:111 = ".$bytes{"1:111"}."\n";  
print "DEBUG: 1:112 = ".$bytes{"1:112"}."\n";  
print "DEBUG: 1:12 =  ".$bytes{"1:12"}."\n"; 

print "\n";
my $cmd = "/usr/bin/rrdtool update /var/rrd/vaih-nbhf/shaping_graph_eth4.rrd " 
        . join(":", ($time,@bytes{"1:10", "1:110", "1:111", "1:112", "1:12"}));

print "$cmd \n";
system ("$cmd");
print "\n";
