#!/bin/bash

# This script must be run by cron and creates the images
#
# 27.4.2004 Philipp Haeuser  www.funkbird.de

IFACE=eth4
NAME=vaih-nbhf
RRDB=/var/rrd/$NAME/shaping_graph_$IFACE.rrd
GRAPHS_DIRECTORY=/var/rrd/$NAME/graphs/


NOW=`date +%s`
ONE_HOUR_AGO=$(($NOW-3600))
ONE_DAY_AGO=$(($NOW-86400))
ONE_WEEK_AGO=$(($NOW-604800))
ONE_MONTH_AGO=$(($NOW-2419200))
ONE_YEAR_AGO=$(($NOW-29030400))
TIMESTAMP="                   Generated on `date`"

function draw_graphic()
{
        rrdtool graph $GRAPHS_DIRECTORY/$1 -s $2 -e $3 -a PNG --height 180 --rigid --upper-limit=280000\
        -t "Bandwidth usage for $4" \
        -l 0 -r \
        DEF:1_12=$RRDB:1_12:AVERAGE CDEF:1_12_net=1_12,1,* AREA:1_12_net#80ff80:"Extern (Internet)" \
        DEF:1_110=$RRDB:1_110:AVERAGE CDEF:1_110_net=1_110,1,* STACK:1_110_net#ff0000:"Wohnheimsnetze ssh" \
        DEF:1_111=$RRDB:1_111:AVERAGE CDEF:1_111_net=1_111,1,* STACK:1_111_net#8080ff:"Wohnheimsnetze SIP-Telefonie" \
        DEF:1_112=$RRDB:1_112:AVERAGE CDEF:1_112_net=1_112,1,* STACK:1_112_net#ff80ff:"Wohnheimsnetze Rest" \
        DEF:1_10=$RRDB:1_10:AVERAGE CDEF:1_10_net=1_10,1,* STACK:1_10_net#404040:"DNS+Management" \
        COMMENT:"\n" \
        COMMENT:"$5\n"
}

draw_graphic 'last_hour.png' $ONE_HOUR_AGO $NOW "$HOSTNAME $IFACE (last 60 minutes)" "$TIMESTAMP" 
draw_graphic 'last_day.png' $ONE_DAY_AGO $NOW "$HOSTNAME $IFACE (last 24 hours)" "$TIMESTAMP"
draw_graphic 'last_week.png' $ONE_WEEK_AGO $NOW "$HOSTNAME $IFACE (last week)" "$TIMESTAMP"
draw_graphic 'last_month.png' $ONE_MONTH_AGO $NOW "$HOSTNAME $IFACE (last month)" "$TIMESTAMP"
draw_graphic 'last_year.png' $ONE_YEAR_AGO $NOW "$HOSTNAME $IFACE (last year)" "$TIMESTAMP"

